# Issues:
#  - Need to be passed a "self" object, so ~/.circle/user_commands.py needs
#    to be given that self thing.
#
#  - Ideally want to make it hard for the user to shoot self in foot.
#

import cStringIO,os,re,string
from types import *

from utility import split_list
import chat, search, hash
#from chat import chat_shell
#from chat import Chat_field

from settings import *
from safe_pickle import *
from file_server import *
from error import Error

def find_task(self, list, online_only=0):
    if not list:
        pipe = self.app.node.retrieve(hash.hash_of('service identity'), identity_redundancy)
    else:
        largest = list[0]
        for item in list[1:]:
            if len(item) > len(largest):
                largest = item

        pipe = self.app.node.retrieve(hash.hash_of('identity-name '+largest), identity_redundancy)

    self.lock.acquire()
    self.search_list = [ ]
    self.lock.release()

    do_gtk(self.show,'Searching...\n')
    while not pipe.finished() and self.running:
        for item in pipe.read_all():
            if online_only:
                demangled = item[1]
            else:
                try:
                    demangled = search.check_and_demangle_item(item[1])
                except Error:
                    continue

            if demangled.get('type','') not in ['identity','identity offline demangled']:
                continue

            keywords = demangled.get('keywords',[ ])
            bad = 0
            for keyword in list:
                if keyword not in keywords:
                    bad = 1
            if bad:
                continue

            #address_name = hostname_of_ip(item[0][0])

            self.lock.acquire()
            try:
                for list_item in self.search_list:
                    if demangled.get('key') == list_item.get('key'):
                        break
                else:
                    self.search_list.append(demangled)
                 
                    #do_gtk(self.show,'%d. %s (%s) at %s\n'%(len(self.search_list),item[1].get('name'),item[1].get('human-name'),address_name))
                    do_gtk(self.show,'%d. %s (%s)\n'%(len(self.search_list),demangled.get('name'),demangled.get('human-name')))
            finally:
                self.lock.release()
        time.sleep(0.5)

    pipe.stop(1)

    do_gtk(self.show,'Search complete.\n')

def do_join(self, param):
    if not param:
        if not self.channel:
            self.show('Use /join <nick> to open communications with nick.\n')
        self.set_channel([ ])
        return

    param = param[0]
    if param[0] in '+-':
        prefix = param[0]
        param = param[1:]
    else:
        prefix = ''
    
    new_list = split_list(param)
    old_list = self.channel[:]

    if prefix == '+':
        for item in old_list:
            if item not in new_list:
                new_list.append(item)

    elif prefix == '-':
        for item in new_list:
            if item in old_list:
                old_list.remove(item)
            else:
                self.show('Not joined to '+item+'\n')
    
        new_list = old_list

    self.set_channel(new_list)
    self.show('Joined ' + string.join(self.channel,',') + '\n')

def do_listen(self, param):
    if not param:
        self.show('Listening to ' + string.join(self.app.channels.get_listening(),',') + '\n')
        return

    param = param[0]
    if param[0] in '+-':
        prefix = param[0]
        param = param[1:]
    else:
        prefix = ''
 
    new_list = split_list(param) 
    for item in new_list:
        if item[:1] <> '#':
            self.show('All channel names must begin with a # character.\n')
            return
    old_list = self.app.channels.get_listening()

    if prefix == '+':
        for item in old_list:
            if item not in new_list:
                new_list.append(item)

    elif prefix == '-':
        for item in new_list:
            if item in old_list:
                old_list.remove(item)
            else:
                self.show('Not listening to '+item+'\n')
    
        new_list = old_list
        
    self.app.channels.set_listening(new_list)
    self.show('Listening to ' + string.join(new_list,',') + '\n')

def do_msg(self, param):
    self.send_message(split_list(param[0]),param[1])
    
def _giveto(self, dest, param):
    expression = param[0]

    if expression[:1] == '!':
        # Python expression
        try:
            result = eval(expression[1:],self.exec_vars)
        except:
            self.show('Error:\n'+\
                string.join(apply(traceback.format_exception,sys.exc_info())))
            return
    else:
        # File
        if not self.use_gtk:
            self.show("This feature does not currently work with the text interface, sorry.\n")
            return

        try:
            if not os.path.isfile(expression):
                raise Error('The file ' + expression + ' does not exist.')
            
            expression = os.path.abspath(expression)
            #self.app.file_server.add_root(expression)
            
            #result = self.app.file_server.get_reference(expression)
            result = self.app.file_server.add_private(expression)
        except Error, error:
            self.show(error.message + '\n')
            return

    if len(param) == 2:
        message = param[1]
    else:
        message = ''

    try:
        attachment = safe_dumps(result)
    except:
        self.show("Couldn't SafePickle your object.")
        return
        
    self.send_message(dest,message,attachment)
    return

def do_give(self, param):
    _giveto(self, self.channel[:], param)

def do_giveto(self, param):
    _giveto(self, split_list(param[0]), param[1:])

def do_take(self, param):
    if not self.use_gtk:
        self.show("This feature does not currently work with the text interface, sorry.\n")
        return
    
    what = param[0]
    self.lock.acquire()
    try:
        if not self.exec_vars.has_key(what) or \
             not self.exec_vars.has_key(what+'_source'):
            self.show('No such reference.\n')
            return
        
        ref = self.exec_vars[what]
        source = self.exec_vars[what+'_source']
        if type(ref) <> type({}) or \
             ref.get('type',None) <> 'file' or \
             type(ref.get('filename',None)) <> type('') or \
             type(ref.get('name',None)) <> type(''):
            self.show('Not a reference to a file.\n')
            return

        try:
            self.app.download_manager.download(ref,[source])
            self.show('Download of ' + ref['filename'] + ' started.\n')
        except Error, error:
            self.show('Problem: ' + error.message + '\n')
    finally:
        self.lock.release()

def do_recall(self, param):
    def recall_task(self,recall_list,field):
        if recall_list == [ ]:
            do_gtk(field.show,'No message to recall.\n')
        else:
            str = ''
            for item in recall_list:
                do_gtk(field.show,str+'Recalling message to '+item[0]+'...\n')
                pipe = self.node.retrieve(item[1],cache_redundancy)
                n    = 0
                while not pipe.finished():
                    for pair in pipe.read_all():
                        if pair[1] == item[2]:
                            try:
                                self.node.call(pair[0],('data cache remove',item[3]))
                                n = n + 1
                            except Error:
                                pass
                    time.sleep(0.25)

                if n == cache_redundancy:
                    str = str + 'Recalled all %d copies of message to %s.\n' % (n,item[0])
                elif n == 0:
                    str = str + 'Could not recall message to %s.\n' % item[0]
                else:
                    str = str + 'Recalled %d copies of message to %s.\n' % (n,item[0])
            
            do_gtk(field.show,str)
        do_gtk(field.close)

    Task(recall_task, self, self.recall_list, self.get_field()).start()
 
def do_quiet(self, param):
    if param:
        self.set_status(1,param[0])
    else:
        self.set_status(not self.quiet, '')
    self.show_status()

def do_me(self, param):
    if param:
        activity = param[0]
    else:
        activity = ''

    self.set_status(0,activity)
    self.show_status()

def do_look(self, param):
    def task(self,nick,field):
        try:
            try:
                acq = self.app.name_server.locate(nick)
            except Error, error:
                do_gtk(field.show,error.message+'\n')
                return
            acq.start_watching(self.node, 1)

            acq.lock.acquire()
            online  = acq.online
            address = acq.address
            name    = acq.name
            acq.lock.release()

            if online:
                result = self.node.call(address,('chat look',))
                if result[0]:
                    if result[1] == '':
                        str = ' is listening'
                    else:
                        str = ' '+result[1]
                else:
                    if result[1] == '':
                        str = ' is quiet'
                    else:
                        str = ' is quiet: ' + result[1]

                str = str + ' (on '+hostname_of_ip(address[0])+')'
                do_gtk(field.show,nick+str+'\n')
        except Error:
            pass

        do_gtk(field.close)

    if param:
        Task(task, self, param[0], self.get_field()).start()
    else:
        self.app.name_server.lock.acquire()
        values = self.app.name_server.acquaintances.values()
        self.app.name_server.lock.release()
        for item in values:
            if item.watch:
                Task(task, self, item.nickname, self.get_field()).start()

def do_who(self, param):
    self.do_who()
    
def do_help(self, param):
    if param:
        # Discard all but first word.
        words = string.split(param[0], maxsplit=1)
        section = words[0]
        
        if section[0] == '/':
            section = section[1:]
        section = '#' + section
    else:
        section = ''
    
    if self.use_gtk:
        try:
            browse_file("chat_commands.html", section)
        except Error, error:
            error.show(self.app.window)
    else:
        stdin_echo(1)
        try:
            browse_file("chat_commands.html", section)
        except Error, error:
            self.show(error.message+'\n')
        stdin_echo(0)

def do_post(self, param):
    if not self.use_gtk:
        self.show("This feature does not currently work with the text interface, sorry.\n")
        return

    self.app.gossip.prompt_for_wodge()

def do_gossip(self, param):
    if not self.use_gtk:
        self.show("This feature does not currently work with the text interface, sorry.\n")
        return

    self.app.gossip.update_and_show_gossip()

def do_stats(self, param):
    self.show(
        'Network usage so far: ' + human_size(self.app.node.network_usage) +
        '\nNumber of known peers: %d\n' % len(self.app.node.peers))

def do_find(self, param):
    if param:
        param = param[0]
    else:
        param = ''

    list = string.split(string.lower(param))
    online_only = 0
    while '-o' in list:
        list.remove('-o')
        online_only = 1
    while '--online' in list:
        list.remove('--online')
        online_only = 1

    Task(find_task,self,list,online_only).start()

def do_add(self, param):
    try:
        value = int(param[0])
    except ValueError:
        raise Error("/add requires a number (ie a result from /find).")

    self.lock.acquire()
    try:
        if value > len(self.search_list):
            raise Error("The list of search results isn't that long.")
        if value < 1:
            raise Error("/add requires a positive number.")
        value = self.search_list[value-1]
    finally:
        self.lock.release()

    def add_task(self,value=value):
        try:
            acq = self.app.name_server.make_acquaintance(value, None)

            acq.lock.acquire()
            acq.watch = 1
            acq.remember = 1
            name = acq.nickname
            acq.lock.release()
            do_gtk(self.show,name + ' has been added to your contact list.\n')
            acq.start_watching(self.app.node)
        except Error, error:
            self.show(error.message+'\n')
    Task(add_task,self).start()

def do_forget(self, param):
    acq = self.app.name_server.nicknames.get(param[0],None)
    if not acq:
        self.show(param[0] + ' is not in your contact list.\n')
        return

    acq.lock.acquire()
    acq.watch = 0
    acq.remember = 0
    acq.lock.release()
    self.show(param[0] + ' has been removed from your contact list.\n')

def do_repeat(self, param):
    try:
        value = int(param[0])
    except ValueError:
        raise Error("/repeat requires a number.")

    if value <= 0:
        return

    self.lock.acquire()
    try:
        list = self.incoming_message_history[-value:]
        if list:
            fields = [self.get_field()]
            while len(fields) < len(list):
                fields.append(fields[-1].child())

            def repeat_task(self,list=list,fields=fields):
                for i in range(len(list)):
                    chat.chat_receive_task(self,list[i][0],None,fields[i],1,list[i][1],0)
            Task(repeat_task,self).start()
    finally:
        self.lock.release()

def do_read(self, param):
    self.show('Displaying unread messages.\n')
    self.lock.acquire()
    try:
        list = self.unread_message_list
        self.unread_message_list = [ ]
        if list:
            fields = [self.get_field()]
            while len(fields) < len(list):
                fields.append(fields[-1].child())
            for i in range(len(list)):
                self.incoming_message_history.append((list[i][0],list[i][2]))

            def read_task(self,list=list,fields=fields):
                for i in range(len(list)):
                    chat.chat_receive_task(self,list[i][0],list[i][1],fields[i],1,list[i][2], 0)
            Task(read_task,self).start()
    finally:
        self.lock.release()

def do_set(self, param):
    if not param: 
        for item in self.app.config_keys:
            self.show(item[1] + ' = ' + self.app.config[item[0]] + '\n')
        return

    match = re.match(r"(\S*)\s*(=|\s)?\s*(.*)",param[0],re.DOTALL)
    if not match:
        raise Error("Couldn't understand your /set command.")

    for item in self.app.config_keys:
        if item[1] == match.group(1):
            self.app.config[item[0]] = match.group(3)
            break
    else:
        self.show("No configuration item called "+match.group(1)+"\n")
        return

    self.app.sync_config()

def do_say(self, param):
    if not self.channel:
        raise Error("Before sending messages, you need to select a person or channel to talk to in the list to the right. If the person is not in the list, you need to search for them in the search box above and add them to your list of contacts.")

    self.send_message(self.channel[:],param[0])

def do_exit(self,param):
    if param:
        message = param[0]
    else:
        message = ''
    self.app.shutdown(message, 0)

def do_logout(self,param):
    if param:
        message = param[0]
    else:
        message = ''
    self.app.shutdown(message, 1)

def register(self):
    """ Register commands. """

    self.register("join", 0,1, do_join)
    self.register("listen", 0,1, do_listen)
    self.register("msg", 2,2, do_msg)
    self.register("give", 1,2, do_give)
    self.register("giveto", 2,3, do_giveto)
    self.register("take", 1,1, do_take)
    self.register("recall", 0,0, do_recall)
    self.register("quiet", 0,1, do_quiet)
    self.register("quietly", 0,1, do_quiet)
    self.register("me", 0,1, do_me)
    self.register("look", 0,1, do_look)
    self.register("who", 0,0, do_who)
    self.register("help", 0,1, do_help)
    self.register("post", 0,0, do_post)
    self.register("gossip", 0,0, do_gossip)
    self.register("stats", 0,0, do_stats)
    self.register("find", 0,1, do_find)
    self.register("add", 1,1, do_add)
    self.register("forget", 1,1, do_forget)
    self.register("repeat", 1,1, do_repeat)
    self.register("read", 0,0, do_read)
    self.register("set", 0,1, do_set)
    self.register("say", 1,1, do_say)
    self.register("exit", 0,1, do_exit)
    self.register("logout", 0,1, do_logout)

